#ifndef __CGLMETASEQ_H
#define __CGLMETASEQ_H
/*
^ZRt@Ci*.mqoj\NX
@ǂݍ݂cGLMetaseqParentNXłB

EŒ̋@\ĂȂłB

gp@
E
PjcGLMetaseqParentNX쐬
QjcGLMetaseqParent::makeGLMetaseq\bhgcGLMetaseqNX쐬

E`@
PjcGLMetaseq::render\bhĂяoΕ`悳܂B
NintendoDS̏ꍇF}eAݒĂ̂ŁA
@glPolyFmt(xxxx | POLY_FORMT_LIGHTx);
@glLight(x,...);
@̗lȌݒȂƕ\ȂƎv܂B

ǂݍ񂾃^ZRt@C̍őlAŏl͈ȉ̕@Ŏo܂B
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	const GLfloat *max = (cGLMetaseqNX).getMaxPoint() ;
	min(max)[0]=x@[1]=y  [2]=z
NintendoDS̏ꍇF_W1.3.12Œ菬_Ȃ̂
@@-8.0`8.0͈̔͂ɓǂݍݎɕϊ܂B

gpFARToolKitɂă^ZRt@C̑}[J_ɒuꍇ
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	glTranslatef(0,0,min[2]*(-1)) ;
	(cGLMetaseqNX).render() ;



^ZRtH[}bg͂B
http://www.metaseq.net/metaseq/format.html

code by kei

*/
#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fat.h>
#include "texturePool_nds.h"
#include <vector>
#include "ndsgl.h"


class cGLMetaseq
{
private :
	friend class cGLMetaseqParent;

	//\p
	typedef struct {		
		GLfloat point[3];	// _z (x, y, z)
		GLfloat normal[3];	// @z (x, y, z)
		GLfloat uv[2];		// UVz (u, v)
	} VERTEX_TEXUSE;
	typedef struct {
		GLfloat point[3];	// _z (x, y, z)
		GLfloat normal[3];	// @z (x, y, z)
	} VERTEX_NOTEX;
	typedef struct {
		bool			isValidMaterialInfo;// }eA̗L/
		bool			isUseTexture;		// eNX`̗LFUSE_TEXTURE / NOUSE_TEXTURE
		GLuint			texture_id;			// eNX`̖O(OpenGL)
		GLuint			VBO_id;				// _obt@ID(OpenGL)@ΉĂ鎞gp
		int				datanum;			// _
		GLfloat			color[4];			// Fz (r, g, b, a)
		VERTEX_NOTEX	*vertex_p;			// |Ŝ݂̎̒_z
		VERTEX_TEXUSE	*vertex_t;			// eNX`gp̒_z
		GLfloat			alpha ;
		rgb				difrgb ;			// gU
		rgb				ambrgb ;			// ͌
		rgb				emirgb ;			// ȏƖ
		rgb				spcrgb ;			// ˌ
		rgb				powrgb ;			// ˌ̋
		u32				*calllist ;			// `pCallList
	} MQO_MATERIAL;
	typedef struct {
		char			objname[256];		// IuWFNgidlɕ̋KȂj
		bool			isVisible;			// 0F\@̑F\
		bool			isShadingFlat ;		// VF[fBO[h
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_MATERIAL>	mat;		// }eAz
	} MQO_INNER_OBJECT;
	typedef struct {
		unsigned char		alpha;				// _z쐬Ɏw肳ꂽAt@liQƗpj
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_INNER_OBJECT *>	obj;		// IuWFNgz
	} MQO_OBJECT;
	typedef struct {
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_OBJECT *>	model;		// f
	} MQO_SEQUENCE;

	MQO_SEQUENCE m_seq ;
	cGLMetaseq(MQO_OBJECT *data) {
		m_seq.minPoint[0] = data->minPoint[0] ;
		m_seq.minPoint[1] = data->minPoint[1] ;
		m_seq.minPoint[2] = data->minPoint[2] ;
		m_seq.maxPoint[0] = data->maxPoint[0] ;
		m_seq.maxPoint[1] = data->maxPoint[1] ;
		m_seq.maxPoint[2] = data->maxPoint[2] ;
		m_seq.model.push_back(data) ;
	}
	void push_back(MQO_OBJECT *data) {
		for( int xyz = 0 ; xyz < 3 ; xyz++ ) {
			if( data->minPoint[xyz] < m_seq.minPoint[xyz] ) 
				m_seq.minPoint[xyz] = data->minPoint[xyz] ;
			if( m_seq.maxPoint[xyz] < data->maxPoint[xyz] ) 
				m_seq.maxPoint[xyz] = data->maxPoint[xyz] ;
		}
		m_seq.model.push_back(data) ;
	}
public :
	virtual ~cGLMetaseq() {
		size_t s,s_num ;
		size_t i,i_num ;
		size_t m,m_num ;
		MQO_OBJECT *obj ;
		MQO_INNER_OBJECT *inner ;
		vector<MQO_INNER_OBJECT *>::iterator inner_it ;
		vector<MQO_OBJECT *>::iterator obj_it ;
		s_num = m_seq.model.size() ;
		for( s = 0 ; s < s_num ; s++ ) {
			obj = m_seq.model.at(s) ;
			i_num = obj->obj.size() ;
			for( i = 0 ; i < i_num ; i++ ) {
				inner = obj->obj.at(i) ;
				m_num = inner->mat.size() ;
				for( m = 0 ; m < m_num ; m++ ) {
					MQO_MATERIAL &mat = inner->mat.at(m) ;
					if( mat.vertex_p != NULL ) free(mat.vertex_p) ;
					if( mat.vertex_t != NULL ) free(mat.vertex_t) ;
					if( mat.calllist != NULL ) free(mat.calllist) ;
				}
				delete inner ;
			}
			delete obj ;
		}
	}
public :
	//ǂݍ񂾃f[^̍ŏliAAjo
	// in frame  t[ԍ@ƑSt[̍ŏl
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMinPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.minPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->minPoint ;
		}
		return NULL ;
	}
	//ǂݍ񂾃f[^̍őliAAjo
	// in frame  t[ԍ@ƑSt[̍ől
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMaxPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.maxPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->maxPoint ;
		}
		return NULL ;
	}
	//ǂݍłt[o
	// ߂l@size_t t[
	size_t getFrameNum() {
		return m_seq.model.size() ;
	}
	//ǂݍł郂f̕`
	// in frame		`悷t[ԍiO`j
	// in alpha		xiOij`QTTj
	void render(int frame = 0) {
		if( m_seq.model.size() <= (unsigned int)frame ) return ;
		MQO_OBJECT *sobj ;
		MQO_INNER_OBJECT	*obj;
		size_t o,o_num ;
		size_t m,m_num ;

		sobj = m_seq.model.at(frame) ;
		glPushMatrix();
			glEnable(GL_ALPHA_TEST);

			o_num = sobj->obj.size() ;
//iprintf("o_num -> %d \n",o_num);
			for ( o=0; o<o_num; o++ ) {	// IuWFNg[v
				obj = sobj->obj.at(o) ;
				m_num = obj->mat.size() ;

				if ( ! obj->isVisible ) continue;
//				glShadeModel(((obj->isShadingFlat))?GL_FLAT:GL_SMOOTH) ;

				for ( m = 0; m < m_num; m++ ) {	//}eA[v
					MQO_MATERIAL &mat = obj->mat.at(m) ;

					if ( mat.datanum == 0 ) continue;
					if ( mat.isValidMaterialInfo ) {	// }eȀݒ
						glMaterialf( GL_DIFFUSE, mat.difrgb);
						glMaterialf( GL_AMBIENT, mat.ambrgb);
						glMaterialf( GL_SPECULAR, mat.spcrgb);
						glMaterialf( GL_EMISSION, mat.emirgb);
						glMaterialf( GL_SHININESS, mat.powrgb);
					}
					if ( mat.isUseTexture) {	// eNX`ꍇ
						glEnable(GL_TEXTURE_2D);
//						glEnable(GL_BLEND);

						glBindTexture(0,mat.texture_id);
//iprintf("mat.calllist -> [%d] \n",mat.calllist[0]);
						glCallList(mat.calllist) ;
						glBindTexture(0,0);

					}
					else {	// eNX`Ȃꍇ

//						glDisable(GL_TEXTURE_2D);
//						glEnable(GL_BLEND);
//iprintf("mat.datanum -> %d \n",mat.datanum);
						glCallList(mat.calllist) ;
					}
				}
			}

		glPopMatrix(1);
	}
};

#include "cGLMetaseqParent_nds.h"
#endif
